#include <libtools.h>
#include <anymap.h>
#include <thread>

typedef std::function<int(com::Anymap)> IntFunc;
typedef std::function<bool(com::Anymap)> BoolFunc;
typedef std::function<std::list<bool>(com::Anymap)> BoolListFunc;  

IntFunc LoadEntry(std::string lib, std::string func) {
    DllHandle handler;
    return com::lib::loadFunction<int (com::Anymap), DllHandle>(lib.c_str(), func.c_str(), handler);
}

BoolFunc LoadPred(std::string lib, std::string func) {
    DllHandle handler;
    return com::lib::loadFunction<int (com::Anymap), DllHandle>(lib.c_str(), func.c_str(), handler);
}

BoolListFunc LoadSelector(std::string lib, std::string func){
    DllHandle handler;
    return com::lib::loadFunction<std::list<bool> (com::Anymap), DllHandle>(lib.c_str(), func.c_str(), handler);
}


int main(int argc, char const *argv[])
{
    auto data = com::Anymap();
    auto predFunc = LoadPred("libprinters", "ReturnTrue"); 
    auto entrFunc = LoadEntry("libprinters", "PrintHello");
    auto selector = LoadSelector("libprinters", "ThreeTrue");
    std::list<bool> ST_selector_val;
    if (!predFunc(data)) {
        std::cout<<"Predicate returned FALSE on state ${}\n"; 
        goto TERM;
    }
    entrFunc(data);

SELECTOR:
    ST_selector_val = selector(data);
    for (int i=0; i<ST_selector_val.size(); i++) {
        std::thread thr();
        goto TERM;
        //if (ST_selector_val.begin+0) {
        //    ST_selector_val.begin+0 = !ST_selector_val.begin+0;
        //    goto TERM;
        //}
        //if (ST_selector_val.begin+1) {
        //    ST_selector_val.begin+1 = !ST_selector_val.begin+1;
        //    goto SELECTOR;
        //}
    }



TERM:
    std::cout<<"Termination!\n"; 
    return 0;
}